# -*- coding: utf-8 -*-

#3a) Il cosiddetto "GC-content" di una sequenza di DNA è il suo contenuto 
# percentuale di basi G e C. Si può calcolare anche il GC-content nell'intorno 
# di una posizione di indice i utilizzando una finestra larga W (dispari) 
# centrata sulla base i-esima. 
# Si scriva una funzione gc_content(s, W) che, data una stringa di DNA e una 
# larghezza di finestra W (dispari), calcoli il GC-content per tutte le 
# posizioni la cui finestra ricada interamente all'interno della stringa.
# L'output deve essere una lista ordinata di tuple, ognuna delle quali deve 
# contenere l'indice della posizione e il GC-content percentuale relativo; 
# le tuple nella lista devono essere ordinate per indice crescente.


def gc_content(s, W):
    W=min(W,(2*len(s)-1)/2) #to enforce W<=s
    if not W%2:
        W+=1      #forced to be an odd width
    W2=W/2
    i_max=len(s)-W2
    n_gc=0
    res=[]
    for i in xrange(W): #GC content of the 1st window
        if s[i]=='G' or s[i]=='C':
            n_gc+=1
    i=W2       
    while True:         #moving forward the window
        res.append( (i, 100*n_gc/float(W)) )
        i+=1
        if i==i_max: 
            break
        n_gc+=s[i+W2]=="G"
        n_gc-=s[i-W2-1]=="G"
        n_gc+=s[i+W2]=="C"
        n_gc-=s[i-W2-1]=="C"
    return res


## another (less efficient) solution by using freqdict from soluzione2
#from soluzione2 import freqdict
#
#def gc_content2(s, W):
#    W=min(W,(2*len(s)-1)/2) #to enforce W<=s
#    if not W%2:
#        W+=1  #forced to be an odd width
#    W2=W/2
#    res=[]
#    for i in xrange(W2, len(s)-W2):
#        d=freqdict(s[i-W2:i+W2+1])
#        tot=0.
#        keys=d.keys()
#        if "G" in keys:
#            tot+=d["G"]
#        if "C" in keys:
#            tot+=d["C"]
#        res.append( ( i, 100*tot ) )        
#    return res
